/* shows the user low/high boundaries of different variable types */
#include <stdio.h>
#include <limits.h>

int main (void) {
  printf("Char\tMin: %i\tMax: %i\tBits: %i\n",CHAR_MIN,CHAR_MAX,CHAR_BIT);
  printf("Short\tMin: %i\tMax: %i\n",SHRT_MIN,SHRT_MAX);
  printf("uShort\tMin: 0\tMax: %i\n",USHRT_MAX);
  printf("Int\tMin: %i\tMax: %i\n",INT_MIN,INT_MAX);
  printf("uInt\tMin: 0\tMax: %u\n",UINT_MAX);
  printf("Long\tMin: %i\tMax: %i\n",LONG_MIN,LONG_MAX);
  printf("LLong\tMin: %i\tMax: %u\n",LLONG_MIN,LLONG_MAX);
  printf("uLLong\tMin: 0\tMax: %u\n",ULLONG_MAX);
  return (0);
}
