/* single concatinated list, with menu */
#include <stdio.h>
#define DEBUG

/*
TODO:
*/

typedef struct person {
  char name [20+1];
  struct person *next;
} Person;

Person * addPerson(Person * person,char name[20+1]) {
printf("addPerson, %p %s\n",person,name);
  if (person == NULL) { /* List is empty, create a new 1st element */
    #ifdef DEBUG
      printf("First list element defined!\n");
    #endif
    person = (Person*)malloc(sizeof(Person));
    person->next=NULL;
    strcpy(person->name,name);
    return person;
  } else {
    #ifdef DEBUG
      printf("Element defined!\n");
    #endif
    Person * temp;
    temp = person->next;
    person->next = (Person*) malloc(sizeof(Person));
    person->next->next = temp;
    strcpy(person->next->name,name);
    return person->next;
  }
}

Person * deletePerson(Person * person) {
  if ((person == NULL)) { /* List is empty, don't do anything */
    #ifdef DEBUG
      printf("Trying to delete first element of an empty list or NULL element! returning arg\n");
    #endif
    return person;
  } else {
    Person * temp;
    temp = person;
    person = person->next;
    free(temp);
    #ifdef DEBUG
      printf("Element deleted and freed!\n");
    #endif
    return person;
  }
}

Person * swapPerson(Person * person) {
  if ((person == NULL)|(person->next==NULL)) { /* List is empty, create a new 1st element */
    #ifdef DEBUG
      printf("Trying to swap the list's last element! No action taken\n");
    #endif
    return person;
  } else {
    Person * temp;
    temp = person->next;
    person->next = temp->next;
    temp->next=person;
    #ifdef DEBUG
      printf("Elements swaped!\n");
    #endif
    return temp;
  }
}

void ShowList(Person * person) {
  while (person != NULL) {
    printf("%s ",person->name);
    person = person->next;
  }
  printf("\n");
}

showmenu () {
  printf("Menu\n=======\n\n1. (A)dd\n2. (S)how List\n3. (D)el\n4. S(w)ap\n5. (E)nd\n");
}
int getnumber () {
   printf("Please enter the number of the element to work on: ");
   int ret; scanf("%i",&ret);
   return ret;
}

Person * getElement(Person * start,int i) {
  if (start==NULL) {return(NULL);}
  for (;i>0 ;--i ) {
printf("getElement .. %i\n",i);
    if (start->next != NULL) {
      start = start->next;
    } else {
      return(start);
    } /* endif */
  } /* endfor */
  return(start);
}


int main () {
  Person *start;
  Person *current;
  start = NULL;
  int pos;
  char name[20+1];
  current = start;
  char ch;
  do {
    showmenu();
    ch = getchar();
    if (ch>90) {ch=ch-32;} /* upp case*/
    switch (ch) {
      case 'A':
        printf("Please enter name: ");
        scanf("%s",name);
        pos = getnumber();
        if (pos > 0) { current = addPerson(getElement(start,pos),name);
          if (pos==1) {start = current;}
        }
      break;
      case 'S': ShowList(current);break;
//      case 'D': current = deletePerson();break;
//      case 'W': current = swapPerson(current);break;
    }
  } while (ch != 'E');  
}
