/* single concatinated list */
#include <stdio.h>
#define DEBUG

/*
TODO:
1. add element done
2. delete element input: pointer to element, out: pointer to next element
3. swap elements input: pointer to first element, out: pointer to new first element
*/

typedef struct person {
  char name [20+1];
  int no;
  struct person *next;
} Person;

Person * addPerson(Person * person,int i) {
  if (person == NULL) { /* List is empty, create a new 1st element */
    #ifdef DEBUG
      printf("First list element defined!\n");
    #endif
    person = (Person*)malloc(sizeof(Person));
    person->next=NULL;
    person->no=i;
    return person;
  } else {
    #ifdef DEBUG
      printf("Element defined!\n");
    #endif
    Person * temp;
    temp = person->next;
    person->next = (Person*) malloc(sizeof(Person));
    person->next->next = temp;
    person->next->no=i;
    return person->next;
  }
}

Person * deletePerson(Person * person) {
  if ((person == NULL)) { /* List is empty, create a new 1st element */
    #ifdef DEBUG
      printf("Trying to delete first element of an empty list or NULL element! returning arg\n");
    #endif
    return person;
  } else {
    Person * temp;
    temp = person;
    person = person->next;
    free(temp);
    #ifdef DEBUG
      printf("Element deleted and freed!\n");
    #endif
    return person;
  }
}

Person * swapPerson(Person * person) {
  if ((person == NULL)|(person->next==NULL)) { /* List is empty, create a new 1st element */
    #ifdef DEBUG
      printf("Trying to swap the list's last element! No action taken\n");
    #endif
    return person;
  } else {
    Person * temp;
    temp = person->next;
    person->next = temp->next;
    temp->next=person;
    #ifdef DEBUG
      printf("Elements swaped!\n");
    #endif
    return temp;
  }
}

void ShowList(Person * person) {
  while (person != NULL) {
    printf("%i ",person->no);
    person = person->next;
  }
  printf("\n");
}

int main () {
  Person *start;
  Person *current;
  
  start = NULL;
  start = addPerson(start,1);
  current = start;

  int i;
  for (i=2;i<6;++i) {
    current = addPerson(current,i);
  }
  ShowList(start);
  start = deletePerson(start);
  ShowList(start);
  start = swapPerson(start);
  ShowList(start);
}
