/* single concatinated list, with menu */
#include <stdio.h>
#define DEBUG

/*
TODO:
*/

typedef struct person {
  char name [20+1];
  int no;
  struct person *next;
} Person;

Person * addPerson(Person * person,int i) {
  if (person == NULL) { /* List is empty, create a new 1st element */
    #ifdef DEBUG
      printf("First list element defined!\n");
    #endif
    person = (Person*)malloc(sizeof(Person));
    person->next=NULL;
    person->no=i;
    return person;
  } else {
    #ifdef DEBUG
      printf("Element defined!\n");
    #endif
    Person * temp;
    temp = person->next;
    person->next = (Person*) malloc(sizeof(Person));
    person->next->next = temp;
    person->next->no=i;
    return person->next;
  }
}

Person * deletePerson(Person * person) {
  if ((person == NULL)) { /* List is empty, create a new 1st element */
    #ifdef DEBUG
      printf("Trying to delete first element of an empty list or NULL element! returning arg\n");
    #endif
    return person;
  } else {
    Person * temp;
    temp = person;
    person = person->next;
    free(temp);
    #ifdef DEBUG
      printf("Element deleted and freed!\n");
    #endif
    return person;
  }
}

Person * swapPerson(Person * person) {
  if ((person == NULL)|(person->next==NULL)) { /* List is empty, create a new 1st element */
    #ifdef DEBUG
      printf("Trying to swap the list's last element! No action taken\n");
    #endif
    return person;
  } else {
    Person * temp;
    temp = person->next;
    person->next = temp->next;
    temp->next=person;
    #ifdef DEBUG
      printf("Elements swaped!\n");
    #endif
    return temp;
  }
}

void ShowList(Person * person) {
  while (person != NULL) {
    printf("%i ",person->no);
    person = person->next;
  }
  printf("\n");
}

showmenu () {
  printf("Menu\n=======\n\n1. (A)dd\n2. (S)how List\n3. (D)el\n4. S(w)ap\n5. (E)nd\n");
}



int main () {
  Person *start;
  Person *current;
  start = NULL;
  int i=1;
  start = addPerson(start,1);
  current = start;
  char ch;
  do {
    showmenu();
    ch = getchar();
    if (ch>90) {ch=ch-32;} /* upp case*/
    switch (ch) {
      case 'A': start = addPerson(start,i++); break;
      case 'S': ShowList(current);break;
      case 'D': current = deletePerson(current);break;
      case 'W': current = swapPerson(current);break;
    }
  } while (ch != 'E');  
/*

  start = addPerson(start,1);
  current = start;

  for (i=2;i<6;++i) {
    current = addPerson(current,i);
  }
  ShowList(start);
  start = deletePerson(start);
  ShowList(start);
  start = swapPerson(start);
  ShowList(start);
*/
}
